//+------------------------------------------------------------------+
//|                              MTF_Silver-channels.mq4             |
//|                                     Copyright  2004, AlexSilver |
//|                                          http://viac.ru/  ik mtf |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, AlexSilver"
#property link      "http://viac.ru/"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 DimGray
#property indicator_color2 DimGray
#property indicator_color3 DarkSlateBlue
#property indicator_color4 DarkSlateBlue
#property indicator_color5 DarkOliveGreen
#property indicator_color6 DarkOliveGreen
#property indicator_color7 DarkSlateBlue
#property indicator_color8 DarkSlateBlue
//---- input parameters
extern int TimeFrame=0;
extern int TSP=9;
extern int SSP=26;
extern int LShift=0;    //mtf sc-linear shift; sc-extention shift/DrawBegin
extern double SilvCh=38.2;
extern double SkyCh=23.6;
extern double ZenCh=0;
extern double FutCh=61.8;
//extern double Shift=0;
//---- buffers
double SCH_BufferH[];
double SCH_BufferL[];
double Sky_BufferH[];
double Sky_BufferL[];
double Zen_BufferH[];
double Zen_BufferL[];
double Fut_BufferL[];
double Fut_BufferH[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----

   SetIndexStyle(0,DRAW_LINE, 0,2,C'68,81,89');
   SetIndexBuffer(0,SCH_BufferH);
   SetIndexDrawBegin(0,SSP-1);
    if(TimeFrame==0) TimeFrame = Period();
    SetIndexShift(0,LShift*TimeFrame/Period());
   SetIndexLabel(0,"Silver-channel H1High38.2("+SSP+")tf"+TimeFrame+"");
//----
   SetIndexStyle(1,DRAW_LINE,0,2,C'68,81,89');
   SetIndexBuffer(1,SCH_BufferL);
   SetIndexDrawBegin(1,SSP-1);
   SetIndexShift(1,LShift*TimeFrame/Period());
   SetIndexLabel(1,"Silver-channel Low38.2("+SSP+")tf"+TimeFrame+"");
//----
   SetIndexStyle(2,DRAW_LINE,0,2,C'54,46,103');
   SetIndexBuffer(2,Sky_BufferH);
   SetIndexDrawBegin(2,SSP-1);
   SetIndexShift(2,LShift*TimeFrame/Period());
   SetIndexLabel(2,"Sky-channel High23.6("+SSP+")tf"+TimeFrame+"");
//----
   SetIndexStyle(3,DRAW_LINE,0,2,C'54,46,103');
   SetIndexBuffer(3,Sky_BufferL);
   SetIndexDrawBegin(3,SSP-1);
   SetIndexShift(3,LShift*TimeFrame/Period());
   SetIndexLabel(3,"Sky-channel Low23.6("+SSP+")tf"+TimeFrame+"");
//----
   SetIndexStyle(4,DRAW_LINE,0,2,C'67,85,36');
   SetIndexBuffer(4,Zen_BufferH);
   SetIndexDrawBegin(4,SSP+LShift-1);
   SetIndexShift(4,LShift*TimeFrame/Period());
   SetIndexLabel(4,"Zen-channel High("+SSP+")tf"+TimeFrame+"");
//----
   SetIndexStyle(5,DRAW_LINE,0,2,C'67,85,36');
   SetIndexBuffer(5,Zen_BufferL);
   SetIndexDrawBegin(5,SSP-1);
   SetIndexShift(5,LShift*TimeFrame/Period());
   SetIndexLabel(5,"Zen-channel Low("+SSP+")tf"+TimeFrame+"");
//----
   SetIndexStyle(6,DRAW_LINE,0,2,C'54,46,103');
   SetIndexBuffer(6,Fut_BufferL);
 //  SetIndexDrawBegin(6,SSP+TSP+LShift-1);
   SetIndexShift(6,TSP*TimeFrame/Period());
   SetIndexLabel(6,"Future-channel Low61.8("+SSP+")tf"+TimeFrame+"");
//----
   SetIndexStyle(7,DRAW_LINE,0,2,C'54,46,103');
   SetIndexBuffer(7,Fut_BufferH);
 //  SetIndexDrawBegin(7,TSP-1);
   SetIndexShift(7,TSP);
   SetIndexLabel(7,"Future-channel High61.8("+SSP+")tf"+TimeFrame+"");
//----   



  //---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }  
    IndicatorShortName("MTF_Silver-channels");
  
   return(0);
  }
//+------------------------------------------------------------------+
//| Silver-channels                                                       |
//+------------------------------------------------------------------+
int start()
  {
  
      datetime TimeArray[];
   int    i,TSP,SSP,LShift,sift, limit, y=0,counted_bars=IndicatorCounted();
     
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   //----------
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++) 
     
{
     if (Time[i]<TimeArray[y]) {y++;}   
    
     SCH_BufferH[i]=iCustom(NULL,TimeFrame,"Silver-channels",0,y); 
     SCH_BufferL[i]=iCustom(NULL,TimeFrame,"Silver-channels",1,y);
     Sky_BufferH[i]=iCustom(NULL,TimeFrame,"Silver-channels",2,y);
     Sky_BufferL[i]=iCustom(NULL,TimeFrame,"Silver-channels",3,y);
     Zen_BufferH[i]=iCustom(NULL,TimeFrame,"Silver-channels",SSP,4,y);
     Zen_BufferL[i]=iCustom(NULL,TimeFrame,"Silver-channels",SSP,5,y);
     Fut_BufferL[i]=iCustom(NULL,TimeFrame,"Silver-channels",TSP,SSP,6,y);
     Fut_BufferH[i]=iCustom(NULL,TimeFrame,"Silver-channels",TSP,SSP,7,y);
 
     
   }
   return(0);
  }
  
  
  
  //------------------------------------------------------------+